﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using WSUniversalLib;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WSUniversalLib.Tests
{
    [TestClass()]
    public class CalculationTests
    {
        [TestMethod()]
        public void GetPriority_Easy1_Return5()
        {
            //Arrange
            float experience = 1.5F, age = 23;
            int agentType = 2;

            int expected = 5;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy2_Return4()
        {
            //Arrange
            float experience = 2, age = 24;
            int agentType = 1;

            int expected = 4;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy3_Return11()
        {
            //Arrange
            float experience = 2.5F, age = 23;
            int agentType = 3;

            int expected = 11;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy4_Return5()
        {
            //Arrange
            float experience = 3, age = 25;
            int agentType = 1;

            int expected = 5;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy5_Return16()
        {
            //Arrange
            float experience = 5, age = 27;
            int agentType = 2;

            int expected = 16;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy6_Return16()
        {
            //Arrange
            float experience = 4, age = 28;
            int agentType = 3;

            int expected = 16;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy7_Return23()
        {
            //Arrange
            float experience = 10, age = 35;
            int agentType = 1;

            int expected = 23;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy8_Return41()
        {
            //Arrange
            float experience = 11, age = 36;
            int agentType = 2;

            int expected = 41;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy9_Return69()
        {
            //Arrange
            float experience = 15, age = 38;
            int agentType = 3;

            int expected = 69;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Easy10_Return108()
        {
            //Arrange
            float experience = 40, age = 60;
            int agentType = 1;

            int expected = 108;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Hard1_ReturnError()
        {
            //Arrange
            float experience = 1.5F, age = 0;
            int agentType = 1;

            int expected = -1;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Hard2_ReturnError()
        {
            //Arrange
            float experience = 0, age = 28;
            int agentType = 1;

            int expected = -1;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Hard3_ReturnError()
        {
            //Arrange
            float experience = 5, age = 28;
            int agentType = 0;

            int expected = -1;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Hard4_ReturnError()
        {
            //Arrange
            float experience = 0, age = 0;
            int agentType = 0;

            int expected = -1;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }

        [TestMethod()]
        public void GetPriority_Hard5_Return300()
        {
            //Arrange
            float experience = 60, age = 80;
            int agentType = 3;

            int expected = 300;

            //Act
            int actual = Calculation.GetPriorityForAgent(agentType, age, experience);

            //Assert
            Assert.AreEqual(expected, actual);
        }
    }
}